DCMTK: DiColorFlipTemplate< T > Class Template Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Private Member Functions | List of all members
DiColorFlipTemplate< T > Class Template Reference

Template class to flip color images (on pixel data level) horizontally and vertically. More...

Inheritance diagram for DiColorFlipTemplate< T >:

## Public Member Functions
| DiColorFlipTemplate (const DiColorPixel *pixel, const Uint16 columns, const Uint16 rows, const Uint32 frames, const int horz, const int vert)
| constructor
| ~DiColorFlipTemplate ()
| destructor
Public Member Functions inherited from DiColorPixelTemplate< T >
| DiColorPixelTemplate (const DiDocument *docu, const DiInputPixel *pixel, const Uint16 samples, EI_Status &status, const Uint16 sample_rate=0)
| constructor
virtual | ~DiColorPixelTemplate ()
| destructor
EP_Representation | getRepresentation () const
| get integer representation
const void * | getData () const
| get pointer to internal array of pixel data.
void * | getDataPtr ()
| get pointer to internal array of pixel data.
void * | getDataArrayPtr ()
| get pointer to internal array of pixel data.
OFBool | getPixelData (void *data, const unsigned long count, const unsigned long fcount, const unsigned long frames, const int planar) const
| fill given memory block with pixel data (all three image planes, RGB)
unsigned long | createDIB (void *&data, const unsigned long size, const Uint16 width, const Uint16 height, const unsigned long frame, const int fromBits, const int toBits, const int mode, const int upsideDown, const int padding) const
| create true color (24/32 bit) bitmap for MS Windows.
unsigned long | createAWTBitmap (void *&data, const Uint16 width, const Uint16 height, const unsigned long frame, const int fromBits, const int toBits) const
| create true color (32 bit) bitmap for Java (AWT default format).
Public Member Functions inherited from DiColorPixel
| DiColorPixel (const DiDocument *docu, const DiInputPixel *pixel, const Uint16 samples, EI_Status &status, const Uint16 sample_rate=0)
| constructor
virtual | ~DiColorPixel ()
| destructor
int | getPlanes () const
| get number of planes
int | getPlanarConfiguration () const
| get planar configuration of the original pixel data
Public Member Functions inherited from DiPixel
| DiPixel (const unsigned long count, const unsigned long inputCount=0)
| constructor
virtual | ~DiPixel ()
| destructor
unsigned long | getCount () const
| get number of pixels
unsigned long | getInputCount () const
| get number of pixels stored in the 'PixelData' element
Public Member Functions inherited from DiPixelRepresentationTemplate< T >
| DiPixelRepresentationTemplate ()
| default constructor
virtual | ~DiPixelRepresentationTemplate ()
| destructor
int | isSigned () const
| check whether template type T is signed or not

## Private Member Functions
void | flip (const T *pixel[3], const int horz, const int vert)
| choose flipping algorithm depending on given parameters

## Additional Inherited Members
Protected Member Functions inherited from DiColorPixelTemplate< T >
| DiColorPixelTemplate (const DiColorPixel *pixel, const unsigned long count)
| constructor
int | Init (const void *pixel)
| initialize internal memory
Protected Member Functions inherited from DiColorPixel
| DiColorPixel (const DiColorPixel *pixel, const unsigned long count)
| constructor
Protected Member Functions inherited from DiFlipTemplate< T >
void | flipHorz (const T *src[], T *dest[])
| flip source image horizontally and store result in destination image
void | flipVert (const T *src[], T *dest[])
| flip source image vertically and store result in destination image
void | flipHorzVert (const T *src[], T *dest[])
| flip source image horizontally and vertically and store result in destination image
| DiFlipTemplate (DiPixel *pixel, const Uint16 columns, const Uint16 rows, const Uint32 frames, const int horz, const int vert)
| constructor.
| DiFlipTemplate (const int planes, const Uint16 columns, const Uint16 rows, const Uint32 frames)
| constructor.
virtual | ~DiFlipTemplate ()
| destructor
void | flipData (const T *src[], T *dest[], const int horz, const int vert)
| choose algorithm depending on flipping mode
Protected Member Functions inherited from DiTransTemplate< T >
| DiTransTemplate (const int planes, const Uint16 src_x, const Uint16 src_y, const Uint16 dest_x, const Uint16 dest_y, const Uint32 frames, const int bits=0)
| constructor
virtual | ~DiTransTemplate ()
| destructor
void | copyPixel (const T *src[], T *dest[])
| copy pixel data
void | fillPixel (T *dest[], const T value)
| fill pixel data with specified value
void | clearPixel (T *dest[])
| clear pixel data (set values to 0)
Protected Attributes inherited from DiColorPixelTemplate< T >
T * | Data [3]
| pointer to pixel data (3 components)
Protected Attributes inherited from DiColorPixel
int | PlanarConfiguration
| planar configuration of the original pixel data (0 = color-by-pixel, 1 = color-by-plane)
Protected Attributes inherited from DiPixel
unsigned long | Count
| number of pixels
unsigned long | InputCount
| number of pixels in the input buffer
Protected Attributes inherited from DiTransTemplate< T >
int | Planes
| number of planes
Uint16 | Src_X
| width of source image
Uint16 | Src_Y
| height of source image
const Uint16 | Dest_X
| width of destination image
const Uint16 | Dest_Y
| height of destination image
const Uint32 | Frames
| number of frames
const int | Bits
| number of bits per plane/pixel

## Detailed Description

template<class T>
class DiColorFlipTemplate< T >

Template class to flip color images (on pixel data level) horizontally and vertically.

## Constructor & Destructor Documentation

## ◆ DiColorFlipTemplate()

template<class T>

DiColorFlipTemplate< T >::DiColorFlipTemplate | ( | const DiColorPixel * | pixel,
|  | const Uint16 | columns,
|  | const Uint16 | rows,
|  | const Uint32 | frames,
|  | const int | horz,
|  | const int | vert )
| inline

constructor

Parameters

  pixel | pointer to intermediate pixel representation
  columns | number of columns
  rows | number of rows
  frames | number of frames
  horz | flip horizontally if true
  vert | flip vertically if true

References DiColorPixel::DiColorPixel(), DiColorPixelTemplate< T >::DiColorPixelTemplate(), DiFlipTemplate< T >::DiFlipTemplate(), and DiPixel::getCount().

## Member Function Documentation

## ◆ flip()

template<class T>

void DiColorFlipTemplate< T >::flip | ( | const T * | pixel[3],
|  | const int | horz,
|  | const int | vert )
| inlineprivate

choose flipping algorithm depending on given parameters

Parameters

  pixel | pointer to pixel data (3 components) which should be flipped
  horz | flip horizontally if true
  vert | flip vertically if true

References DiColorPixelTemplate< T >::Data, DiFlipTemplate< T >::flipHorz(), DiFlipTemplate< T >::flipHorzVert(), DiFlipTemplate< T >::flipVert(), and DiColorPixelTemplate< T >::Init().

The documentation for this class was generated from the following file:

- dcmimage/include/dcmtk/dcmimage/dicoflt.h

Generated on Wed Apr 30 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2